﻿#region Using directives

using System;
using System.Collections.Generic;
using System.Globalization;
using System.Windows.Forms;

#endregion

namespace InputLanguagesSample {
  static class Program {
    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main() {

      // Change input language to Australian English
      InputLanguage lng = InputLanguage.FromCulture(new CultureInfo("en-AU"));
      Application.CurrentInputLanguage = lng; // one way
      InputLanguage.CurrentInputLanguage = lng; // another way

      // Reinstate default
      Application.CurrentInputLanguage = InputLanguage.DefaultInputLanguage;

      Application.EnableVisualStyles();
      Application.SetCompatibleTextRenderingDefault(false);
      Application.Run(new MainForm());
    }
  }
}