﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;

#endregion

namespace SingleMDISample {
  partial class MDIChildForm : Form {

    private string fileName;

    public MDIChildForm() {
      InitializeComponent();
      MDIParentForm.FormCount++;
    }

    public void OpenFile(string fileName) {
      this.fileName = fileName;
      if( !string.IsNullOrEmpty(fileName) ) {
        using( StreamReader reader = new StreamReader(fileName) ) {
          this.textBox.Text = reader.ReadToEnd();
        }
      }
      else this.fileName = "Untitled" + MDIParentForm.FormCount.ToString();
      this.Text = "MDI Child Form - " + this.fileName;
    }
    
    public string FileName {
      get { return this.fileName; }
    }

    private void closeToolStripMenuItem_Click(object sender, EventArgs e) {
      this.Close();
    }
  }
}