using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace AppliedDataBindingSample {
  public partial class EmployeeItemForm : Form {

    public EmployeeItemForm(object item) {
      
      // Check that item is a DataRowView for an EmployeesRow
      if( (item is DataRowView) &&
          (((DataRowView)item).Row is NorthwindDataSet.EmployeesRow) ) {
        InitializeComponent();
        // Acquire employee list data source item
        this.employeesBindingSource.DataSource = item;
      }
      else throw new ArgumentException("Incorrect type");
    }

    private void getPhotoButton_Click(object sender, EventArgs e) {
      if( this.openFileDialog.ShowDialog() == DialogResult.OK) {
        this.photoPathTextBox.Text = this.openFileDialog.FileName;
        Image newImage = Image.FromFile(this.openFileDialog.FileName);
        this.photoPictureBox.Image = newImage;
      }
    }

    private void EmployeeItemForm_FormClosing(object sender, FormClosingEventArgs e) {
      // Cancel edit if cancel button is pressed, or form is closed from 
      // either the control box or close box
      if( e.CloseReason == CloseReason.UserClosing || this.DialogResult == DialogResult.Cancel ) {
        this.employeesBindingSource.CancelEdit();
      }
    }
  }
}